var JsBarcode = require('jsbarcode');

var Barcode = {
  template: `
  <div>
    <svg class="vue-barcode-element" v-show="valid"></svg>
    <div v-show="!valid">
      <slot></slot>
    </div>
   </div>`,
  props: {
    value: [String, Number],
    height: [String, Number],
  },
  mounted: function(){
    this.$watch('$props', render, { deep: true, immediate: true });
    render.call(this);
  },
  data: function(){
    return {valid: true};
  }
};

function render(){
  JsBarcode(this.$el.querySelector('.vue-barcode-element'), this.value, {
    height: this.height,
    valid: valid => {
      this.valid = valid;
    }
  });
}

module.exports = Barcode;
